/**
* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/

/**
 *
 * Contains all the configuration parameters used by monitor
 * and network bandwidth predictor
 */
public class Config {
	public NNConfig nnConfig;
	public FIConfig fiConfig;
	public NWSMonitorConfig nwsMonitorConfig;
	public DBConfig dbConfig;
}
/**
 * 
 *
 * configuration perameters for neural network
 */
class NNConfig{
	public float learningRate;
	public int maxOfEpochs;
	public int noOFHiddenLayers;
}

/**
 * 
 *
 * Configuration parameters for predictor
 */
class FIConfig{
	public int predictionStepFrom;
	public int predictionStepTo;
	public int predictionStepStep;
	public int binSizeFrom;
	public int binSizeTo;
	public int binSizeStep;
}

/**
 * 
 *
 * Configuration parameters for NWS monitor
 */
class NWSMonitorConfig{
	public String sourceMachine;
	public String destMachine;
	public String noOfMeasurements;
	public String skillToMonitor;
	public String period;
	public String totalDataSize;
	public String sendMsgSize;
	public String socketBufferSize;	
}

/**
 * 
 * 
 * Database connection information
 */
class DBConfig{
	public String connectionString;
	public String userName;
	public String password;
	public String driverName;
}

/**
 * 
 * 
 * SSH connection information
 */
class SSHConfig{
	public String serverName;
	public String userName;
	public String password;
	public int port;
}

