/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.io.*;
import java.sql.*;
/**
 * 
 * Load the data & results into database
 * /
 
 
/*
 * DataLoader.java
 *
 * Created on March 23, 2004, 1:52 PM
 */


public class DataLoader {
    
	private DBConfig config = null;
    static{
       
    }
    /** Creates a new instance of DataLoader */
    public DataLoader(DBConfig config) {
		this.config = config;
		 try{
            Class.forName(config.driverName);
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public String load(String fileName) throws Exception{
        BufferedReader reader = new BufferedReader(new FileReader(fileName));
        String query = "insert into stat(stat_id,timestamp,avg_no_of_bits) " +
                       " values(?,?,?) ";
        Connection conn  = DriverManager.getConnection(config.connectionString, config.userName, config.password);
        PreparedStatement pstmt = conn.prepareStatement(query);
        String seqQuery = "Select stat_seq.nextval from dual";
        PreparedStatement sqlPst = conn.prepareStatement(seqQuery);
        ResultSet rs = sqlPst.executeQuery();
        long seqNumber = -1;
        if(rs.next()){
            seqNumber = rs.getLong(1);
        }
        while(true){
            String line = reader.readLine();
            if(line==null) break;
            //parse the line and insert into database.. 
            //set the parameter
            try{
            	Row row = new Row(line);
                pstmt.setLong(1, seqNumber);
                pstmt.setTimestamp(2,new Timestamp(Long.parseLong(row.getValue(0))*1000));
                pstmt.setDouble(3, Double.parseDouble(row.getValue(4)));
                pstmt.executeUpdate();
            }catch(Exception e){
                //write to fallout file..
                e.printStackTrace();
            }
        }
        conn.close();
        reader.close();
        return Long.toString(seqNumber);
    }
    
    public long toLong(String str){
       return Long.parseLong(str.trim());
    }
    
   
    
}
