/**

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
/**
 *
 * This class creats a thread and run the actual prediction
 * in the thread. This design allows user to interact with 
 * GUI in responsive manner
 * */
public class PredictorRunner implements Runnable{
	private GUI gui=null;
	private String fileName = null;
	private String statId = "1";
	private DBConfig dbConfig = null;
	
	public PredictorRunner(GUI gui,DBConfig dbConfig,String fileName){
		this.gui=gui;
		this.fileName = fileName;
		this.dbConfig = dbConfig;
	}
	
	public PredictorRunner(GUI gui,String statId, DBConfig dbConfig){
		this.gui = gui;
		this.statId=statId;
		this.dbConfig = dbConfig;
	}
	
	public boolean done = false;
	public void run(){
		if(fileName==null){
			fileName = "temp"+statId+".txt";
			DataExtractor extractor = new DataExtractor(dbConfig);
			try{
				extractor.extract(statId,fileName);
			}catch(Exception e){
				e.printStackTrace();
			}
		}else{
			//the data is coming from file .. write to database
			DataLoader loader = new DataLoader(dbConfig);
			try{
				statId=loader.load(fileName);
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		done = false;
		Config config = gui.getConfig();
		System.out.println("inside run"+fileName);
		gui.setStatus("Loading file");
		//set the status...
		ParseInput parser = new ParseInput();
		//call the paree input
		//update the status
		for(int i= config.fiConfig.binSizeFrom;i<=config.fiConfig.binSizeTo;
					i+=config.fiConfig.binSizeStep){
			for(int j=config.fiConfig.predictionStepFrom;j<config.fiConfig.predictionStepTo;
						j+=config.fiConfig.predictionStepStep){
				gui.setStatus("processing"+i);
				System.out.println("calling parse data");
				parser.processData(fileName, fileName+i+".tmp",  i ,gui); //for timebeing..
				System.out.println("calling generateFinalInputANN");
				parser.generateFinalInputANN(fileName+i+".tmp", fileName+i+".out",gui,j);
				BandwidthPredictor bp = new BandwidthPredictor(BandwidthPredictor.Columns ,
						fileName+i+".out",fileName+i+".res" , config);
				bp.get_estimate();
				ResultsLoader resLoader= new ResultsLoader(dbConfig);
				try{
					resLoader.load(fileName+i+".res",Long.parseLong(statId),(long)i);
				}catch(Exception e){
					e.printStackTrace();
				}
				//create a run in the database..
 			    //load the intermediate result
				//load this result into database
			}
		}
 
		//call the predicotr
		//udpate the status
		gui.setStatus("done");
		done = true;
		ResultsPanel rPanel = (ResultsPanel) gui.getCurrentPanel();
		rPanel.display(this);
	}
	
	public String getResultFileName(){
		return fileName+gui.getConfig().fiConfig.binSizeFrom+".res";
	}
}
