/**

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.util.LinkedList;

import javax.swing.table.DefaultTableModel;

/**
 *
 *  Represents the content of result of a prediction.
 *  Used in display results table in jtable
 *  Used in creating chart from results 
 */

public class ResultDataModel extends DefaultTableModel{
	public String columns[]= {"Timestamp","Measured","Predicted","Error"};
	private LinkedList data=new LinkedList();
	public static final int COL_TIME = 0;
	public static final int COL_MESSURED = 1;
	public static final int COL_PREDICTED = 2;
	public static final int COL_ERROR = 3;
	
	public ResultDataModel(LinkedList list){
		data=list;
	}
	
	public void setData(LinkedList data){
		this.data = data;
		this.fireTableDataChanged();
	}
	//public String 
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */
	public int getColumnCount() {
		// TODO Auto-generated method stub
		return columns.length;
	}
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnName(int)
	 */
	public String getColumnName(int column) {
		// TODO Auto-generated method stub
		return columns[column];
	}
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		// TODO Auto-generated method stub
		if(data==null) return 0;
		return data.size();
	}
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int row, int column) {
		// TODO Auto-generated method stub
		Result result = (Result) data.get(row);
		switch(column){
			case COL_TIME:
				return result.time;
			case COL_MESSURED:
				return result.measured;
			case COL_PREDICTED:
				return result.predicted;
			case COL_ERROR:
				return result.error;
			default:
				return null;
		}
	}
}

