/**

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.util.*;
import javax.swing.*;

import org.jCharts.Chart;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*
;
/**
 *
 * Contains a jtable which displays the result of a prediction
 * ran by the user
 */
public class ResultsPanel extends JPanel{
	JLabel lblTitle = new JLabel("Prediction Results");
	JTable tblResults = null; 
	JButton btnCancel = new JButton("Cancel");
	JButton btnGraph = new JButton("Get Graph");
	private GUI gui = null;
	ResultDataModel dataModel =  null;
	ActionListener cancelListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			gui.backToMain();
		}
	};
	public ResultsPanel(GUI gui){
		this.gui = gui;
		LinkedList results = new LinkedList();
		results.add(new Result("1","1","1","1"));
		dataModel = new ResultDataModel(results);
		tblResults=new JTable(dataModel);
		tblResults.setPreferredSize(new Dimension(300,400));
		JScrollPane pane=new JScrollPane(tblResults);
		pane.setPreferredSize(new Dimension(300,400));
		//tblResults.setModel(dataModel);
		setLayout(new BorderLayout());
		add(lblTitle,BorderLayout.NORTH);
		add(pane,BorderLayout.CENTER);
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new GridLayout());
		btnPanel.add(btnGraph);
		btnPanel.add(btnCancel);
		add(btnPanel,BorderLayout.SOUTH);
		btnCancel.addActionListener(cancelListener);
		
		btnGraph.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				displayGraph();
			}
		});
	}
	
	public void displayGraph(){
		try{
			ChartGenerator generator = new ChartGenerator();
			JFrame f = new JFrame();
			f.setSize(400,400);
			Chart chart = generator.generateChart(dataModel);
			f.getContentPane().add(new javax.swing.JLabel(new javax.swing.ImageIcon(generator.render(chart))), java.awt.BorderLayout.CENTER);
		    f.pack();
		    f.show();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static void main(String argv[]){
		   JFrame frame = new JFrame("NN Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   ResultsPanel nnPanel = new ResultsPanel(null);
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(nnPanel,BorderLayout.CENTER);
		   frame.validate();
	 }

	
	public void display(PredictorRunner runner){
		
		System.out.println("after the wait..");
		BufferedReader fin=null;
		try{
			fin=new BufferedReader(new  FileReader(runner.getResultFileName()));
			System.out.println(fin);
			String line =null;
			LinkedList list = new LinkedList();
			while(true){
				line = fin.readLine();
				if(line==null) break;
				Row row = new Row(line);
				Result result = new Result(row.getValue(0),
										row.getValue(1),
										row.getValue(2),
										row.getValue(3));
				list.add(result);
			}
			dataModel.setData(list);
			
		}catch(FileNotFoundException fe){
			fe.printStackTrace();
		}catch(IOException ioe){
			ioe.printStackTrace();
		}	finally{
			try{
				if(fin!=null) fin.close();
			}catch(Exception ignore){}
		}
		
		
	}

}

class Result{
	public String time;
	public String measured;
	public String predicted;
	public String error;
	
	public Result(String time, String measured, String predicted, String error){
		this.time = time;
		this.measured = measured;
		this.predicted = predicted;
		this.error = error;
	}

}