/**

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.*;
import java.awt.*;

/**
 *
 * ssh sheel which allows user to typein a command to be executed
 * User can also start name server, memory server , sensor 
 * and activity by sigle keystroke
 */
public class SSHPanel extends JPanel{
	JButton okButton = new JButton("Enter");
	JButton cancelButton = new JButton("Cancel");
	SSHConfig sshConfig = null;
    SSH1Example ssh1= null;
    SSHConfigPanel configPanel = null;
	GUI gui = null;
	JTextArea out = new JTextArea();
	JTextField prompt = new JTextField();
	ActionListener cancelListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			try{
				ssh1.runSCP(".cshrc"); // Must exist - change if needed.
			}catch(Exception ex){
				ex.printStackTrace();
			}
			gui.backToMain();
		}
	};
	
	ActionListener okListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			//execute the commend
			execute();
		}
	};
	
	public void connect(){
		sshConfig = configPanel.getConfig();
		ssh1 =	new SSH1Example(sshConfig.serverName,sshConfig.port+"",sshConfig.userName,sshConfig.password);
		//new SSH1Example("216.47.150.106", "22", "wuming", "wmalak003");
	    try{
	    	ssh1.runWithPortFwd();
	    }catch(Exception ex){
	    	//incorrect connection info.. 
	    	JOptionPane.showMessageDialog(this, "Incorrect connection info or Unable to connect to SSH server based on provided information");
	    	//ex.printStackTrace();
	    	return;
	    }
    
		this.removeAll();
		initialize();
	}
	
	public void cancel(){
		gui.backToMain();	
	}
	
	private void addHelp(){
		out.append("***********************************\n");
		out.append("Type one of the numbers to perform \ncorresponding function\n");
		out.append(" 1   Start Name Server\n");
		out.append(" 2   Start Memory\n");
		out.append(" 3   Start Sensor\n");
		out.append(" 4   Start Activity\n");
		out.append("***********************************\n");
		
	}
	
	private void execute(){
		String command = prompt.getText();
		if(command.equals("1")){
			command = getStartName();
		}else if(command.equals("3")){
			command = getStartSensor();
		}else if(command.equals("2")){
			command = getStartMemory();
		}else if(command.equals("4")){
			command = getStartActivity();
		}
		out.append("$");
		out.append(command);
		out.append("\n");
		try{
			out.append(ssh1.runWithCommand(command).toString());
			out.append("----------------------------------------\n");
		}catch(Exception ex){
			ex.printStackTrace();
		}
		prompt.setText("");
		addHelp();
	}
	
	public SSHPanel(GUI gui){
		//first get user preference from user...
		this.setPreferredSize(new Dimension(300,450));
		this.gui = gui;
		configPanel=new SSHConfigPanel(this);
		this.add(configPanel);
				
	}
	
	private void initialize(){
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		//out.setPreferredSize(new Dimension(300,380));
		out.setEditable(false);
		out.setLineWrap(true);
		JScrollPane scroll = new JScrollPane(out);
		scroll.setPreferredSize(new Dimension(300,430));
		add(scroll);
		JPanel pnl = new JPanel();
		pnl.setLayout(new BoxLayout(pnl,BoxLayout.X_AXIS));
		prompt.setColumns(10);
		pnl.add(prompt);
		pnl.add(okButton);
		pnl.add(cancelButton);
		add(pnl);
		cancelButton.addActionListener(cancelListener);
		okButton.addActionListener(okListener);
		revalidate();
		repaint();
		
	    addHelp();
	
	}
	
	public String getStartName(){
		return "nohup ./nms_nameserver -e name.err -l name.log";
	}
	public String getStartSensor(){
		return "nohup ./nms_sensor -e sensor.err -l sensor.log";
	}
	public String getStartMemory(){
		return "nohup ./nms_memory -e memory.err -l memory.log";
	}
	public String getStartActivity(){
		NWSMonitorConfig config = gui.getConfig().nwsMonitorConfig;
		return "nohup ./start_activity -F "+ config.sourceMachine + 
			" skillName:" + config.skillToMonitor  +
			" member:"+ config.sourceMachine +
			" member:"+ config.destMachine +
			" controlName:clique name:mytrace"+
			" message:"+ config.sendMsgSize+
			" period:"+ config.period +
			" buffer:"+config.socketBufferSize +
			" size:"+ config.totalDataSize;
	}
}
